(function () {
    "use strict";

    angular.module('core').controller('tabelaPrecoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'tabelaPrecoService', '$alert','lookupService', '$q'];

    function controller($scope, $timeout, $state, $stateParams, tabelaPrecoService, $alert, lookupService, $q) {
        $scope.initializeLayout('Tabela de Preços');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            tabCorrente: 0,
            precosProdutos: { args: { tabelaPrecoID: decodeURIComponent($stateParams.id), skip: 0, take: 20 }, data: [] },
            precosServicos: { args: { tabelaPrecoID: decodeURIComponent($stateParams.id), skip: 0, take: 20 }, data: [] },
        };


        $scope.auxiliar = {
            tabelapreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            tabelaPrecoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.save = function () {
            $scope.state.salvando = true;
            tabelaPrecoService
                .save($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.state.item = {};
                        $scope.historyBack();
                    }
                    $scope.state.salvando = false;
                },
                function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            tabelaPrecoService
                .delete($scope.state.item.ID)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.state.item = null;
                        $scope.historyBack();
                    }
                    $scope.state.salvando = false;
                },
                function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        };

        $scope.getAllPrecosProdutos = function () {
            $scope.state.precosProdutos.args.skip = 0;
            $scope.state.precosProdutos.args.take = 20;
            tabelaPrecoService
                .getAllPrecoProduto($scope.state.precosProdutos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.precosProdutos.data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        }
        $scope.getAllPrecosServicos = function () {
            $scope.state.precosServicos.args.skip = 0;
            $scope.state.precosServicos.args.take = 20;
            tabelaPrecoService
                .getAllPrecoServico($scope.state.precosServicos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.precosServicos.data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        }

        $scope.getMorePrecosProdutos = function () {
            $scope.state.precosProdutos.args.skip += $scope.state.precosProdutos.args.take;
            tabelaPrecoService
                .getAllPrecoProduto($scope.state.precosProdutos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.precosProdutos.data = $scope.state.precosProdutos.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        }
        $scope.getMorePrecosServicos = function () {
            $scope.state.precosServicos.args.skip += $scope.state.precosServicos.args.take;
            tabelaPrecoService
                .getAllPrecoServico($scope.state.precosServicos.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.precosServicos.data = $scope.state.precosServicos.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        }

        $scope.refresh = function () {
            $scope.get();
            $scope.getAllPrecosProdutos();
            $scope.getAllPrecosServicos();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();